Properties Methods Events Config Options Direct Link

    Observable
      Component
        BoxComponent
          Container
            Panel
              GridPanel
                EditorGridPanel

# Class Ext.grid.EditorGridPanel

Package: | Ext.grid
Defined In: | EditorGrid.js
Class: | EditorGridPanel
Subclasses: | PropertyGrid
Extends: | GridPanel

Class for creating and editable grid.

## Config Options

Config Options | Defined By
--- | ---

activeItem : String/Number
A string component id or the numeric index of the component that should be initially activated within the container's...
A string component id or the numeric index of the component that should be initially activated within the container's layout on render. For example, activeItem: 'item-1' or activeItem: 0 (index 0 = the first item in the container's collection). activeItem only applies to layout styles that can display items one at a time (like Ext.layout.Accordion, Ext.layout.CardLayout and Ext.layout.FitLayout). Related to Ext.layout.ContainerLayout.activeItem.

Container

| allowDomMove : Boolean Whether the component can move the Dom node when rendering (defaults to true). | Component
| animCollapse : Boolean True to animate the transition when the panel is collapsed, false to skip the animation (defaults to true if the Ext.... True to animate the transition when the panel is collapsed, false to skip the animation (defaults to true if the Ext.Fx class is available, otherwise false). | Panel

applyTo : Mixed
The id of the node, a DOM node or an existing Element corresponding to a DIV that is already present in the document ...
The id of the node, a DOM node or an existing Element corresponding to a DIV that is already present in the document that specifies some structural markup for this component. When applyTo is used, constituent parts of the component can also be specified by id or CSS class name within the main element, and the component being created may attempt to create its subcomponents from that markup if applicable. Using this config, a call to render() is not required. If applyTo is specified, any value passed for renderTo will be ignored and the target element's parent node will automatically be used as the component's container.

Component

| autoDestroy : Boolean If true the container will automatically destroy any contained component that is removed from it, else destruction mu... If true the container will automatically destroy any contained component that is removed from it, else destruction must be handled manually (defaults to true). | Container
| autoExpandColumn : String The id of a column in this grid that should expand to fill unused space. This id can not be 0. | GridPanel
| autoExpandMax : Number The maximum width the autoExpandColumn can have (if enabled). Defaults to 1000. | GridPanel
| autoExpandMin : Number The minimum width the autoExpandColumn can have (if enabled). defaults to 50. | GridPanel
| autoHeight : Boolean True to use height:'auto', false to use fixed height (defaults to false). | BoxComponent

autoLoad : Object/String/Function
A valid url spec according to the Updater Ext.Updater.update method. If autoLoad is not null, the panel will attempt ...
A valid url spec according to the Updater Ext.Updater.update method. If autoLoad is not null, the panel will attempt to load its contents immediately upon render.

The URL will become the default URL for this panel's body element, so it may be refreshed at any time.

Panel

| autoScroll : Boolean True to use overflow:'auto' on the panel's body element and show scroll bars automatically when necessary, false to c... True to use overflow:'auto' on the panel's body element and show scroll bars automatically when necessary, false to clip any overflowing content (defaults to false). | Panel
| autoShow : Boolean True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render... True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render (defaults to false). | Component
| autoWidth : Boolean True to use width:'auto', false to use fixed width (defaults to false). | BoxComponent
| baseCls : String The base CSS class to apply to this panel's element (defaults to 'x-panel'). | Panel

bbar : Object/Array
The bottom toolbar of the panel. This can be a Ext.Toolbar object, a toolbar config, or an array of buttons/button co...
The bottom toolbar of the panel. This can be a Ext.Toolbar object, a toolbar config, or an array of buttons/button configs to be added to the toolbar. Note that this is not available as a property after render. To access the bottom toolbar after render, use getBottomToolbar.

Panel

bodyBorder : Boolean
True to display an interior border on the body element of the panel, false to hide it (defaults to true). This only a...
True to display an interior border on the body element of the panel, false to hide it (defaults to true). This only applies when border == true. If border == true and bodyBorder == false, the border will display as a 1px wide inset border, giving the entire body element an inset appearance.

Panel

| bodyStyle : String/Object/Function Custom CSS styles to be applied to the body element in the format expected by Ext.Element.applyStyles (defaults to nu... Custom CSS styles to be applied to the body element in the format expected by Ext.Element.applyStyles (defaults to null). | Panel
| border : Boolean True to display the borders of the panel's body element, false to hide them (defaults to true). By default, the borde... True to display the borders of the panel's body element, false to hide them (defaults to true). By default, the border is a 2px wide inset border, but this can be further altered by setting bodyBorder to false. | Panel

bufferResize : Boolean/Number
When set to true (100 milliseconds) or a number of milliseconds, the layout assigned for this container will buffer t...
When set to true (100 milliseconds) or a number of milliseconds, the layout assigned for this container will buffer the frequency it calculates and does a re-layout of components. This is useful for heavy containers or containers with a large amount of sub components that frequent calls to layout are expensive.

Container

| buttonAlign : String The alignment of any buttons added to this panel. Valid values are 'right,' 'left' and 'center' (defaults to 'right'). | Panel
| buttons : Array An array of Ext.Button configs used to add buttons to the footer of this panel. | Panel
| clicksToEdit : Number The number of clicks on a cell required to display the cell's editor (defaults to 2) | EditorGridPanel
| cls : String An optional extra CSS class that will be added to this component's Element (defaults to ''). This can be useful for a... An optional extra CSS class that will be added to this component's Element (defaults to ''). This can be useful for adding customized styles to the component or any of its children using standard CSS rules. | Component
| cm : Object Shorthand for colModel. | GridPanel
| colModel : Object The Ext.grid.ColumnModel to use when rendering the grid (required). | GridPanel
| collapseFirst : Boolean True to make sure the collapse/expand toggle button always renders first (to the left of) any other tools in the pane... True to make sure the collapse/expand toggle button always renders first (to the left of) any other tools in the panel's title bar, false to render it last (defaults to true). | Panel
| collapsed : Boolean True to render the panel collapsed, false to render it expanded (defaults to false). | Panel
| collapsedCls : String A CSS class to add to the panel's element after it has been collapsed (defaults to 'x-panel-collapsed'). | Panel
| collapsible : Boolean True to make the panel collapsible and have the expand/collapse toggle button automatically rendered into the header ... True to make the panel collapsible and have the expand/collapse toggle button automatically rendered into the header tool button area, false to keep the panel statically sized with no button (defaults to false). | Panel
| columns : Array An array of columns to auto create a ColumnModel | GridPanel
| contentEl : String The id of an existing HTML node to use as the panel's body content (defaults to ''). | Panel
| ctCls : String An optional extra CSS class that will be added to this component's container (defaults to ''). This can be useful for... An optional extra CSS class that will be added to this component's container (defaults to ''). This can be useful for adding customized styles to the container or any of its children using standard CSS rules. | Component
| defaultType : String The default type of container represented by this object as registered in Ext.ComponentMgr (defaults to 'panel'). | Container

defaults : Object
A config object that will be applied to all components added to this container either via the items config or via the...
A config object that will be applied to all components added to this container either via the items config or via the add or insert methods. The defaults config can contain any number of name/value property pairs to be added to each item, and should be valid for the types of items being added to the container. For example, to automatically apply padding to the body of each of a set of contained Ext.Panel items, you could pass: defaults: {bodyStyle:'padding:15px'}.

Container

| disableSelection : Boolean True to disable selections in the grid (defaults to false). - ignored a SelectionModel is specified | GridPanel
| disabledClass : String CSS class added to the component when it is disabled (defaults to "x-item-disabled"). | Component
| draggable : Boolean True to enable dragging of this Panel (defaults to false). For custom drag/drop implementations, an Ext.Panel.DD conf... True to enable dragging of this Panel (defaults to false). For custom drag/drop implementations, an Ext.Panel.DD config could also be passed in this config instead of true, although Ext.Panel.DD is an internal, undocumented class. | Panel

elements : String
A comma-delimited list of panel elements to initialize when the panel is rendered. Normally, this list will be genera...
A comma-delimited list of panel elements to initialize when the panel is rendered. Normally, this list will be generated automatically based on the items added to the panel at config time, but sometimes it might be useful to make sure a structural element is rendered even if not specified at config time (for example, you may want to add a button or toolbar dynamically after the panel has been rendered). Adding those elements to this list will allocate the required placeholders in the panel when it is rendered. Valid values are

- header
- tbar (top bar)
- body
- bbar (bottom bar)
- footer

Defaults to 'body'.

Panel

| enableColumnHide : Boolean True to enable hiding of columns with the header context menu. | GridPanel
| enableColumnMove : Boolean True to enable drag and drop reorder of columns. | GridPanel
| enableColumnResize : Boolean False to turn off column resizing for the whole grid (defaults to true). | GridPanel
| enableDragDrop : Boolean True to enable drag and drop of rows. | GridPanel
| enableHdMenu : Boolean True to enable the drop down button for menu in the headers. | GridPanel
| enableRowHeightSync : Boolean True to manually sync row heights across locked and not locked rows. | GridPanel

floating : Boolean
True to float the panel (absolute position it with automatic shimming and shadow), false to display it inline where i...
True to float the panel (absolute position it with automatic shimming and shadow), false to display it inline where it is rendered (defaults to false). Note that by default, setting floating to true will cause the panel to display at negative offsets so that it is hidden -- because the panel is absolute positioned, the position must be set explicitly after render (e.g., myPanel.setPosition(100,100);). Also, when floating a panel you should always assign a fixed width, otherwise it will be auto width and will expand to fill to the right edge of the viewport.

Panel

| footer : Boolean True to create the footer element explicitly, false to skip creating it. By default, when footer is not specified, if... True to create the footer element explicitly, false to skip creating it. By default, when footer is not specified, if one or more buttons have been added to the panel the footer will be created automatically, otherwise it will not. | Panel
| frame : Boolean True to render the panel with custom rounded borders, false to render with plain 1px square borders (defaults to false). | Panel

header : Boolean
True to create the header element explicitly, false to skip creating it. By default, when header is not specified, if...
True to create the header element explicitly, false to skip creating it. By default, when header is not specified, if a title is set the header will be created automatically, otherwise it will not. If a title is set but header is explicitly set to false, the header will not be rendered.

Panel

| headerAsText : Boolean True to display the panel title in the header, false to hide it (defaults to true). | Panel
| height : Number The height of this component in pixels (defaults to auto). | BoxComponent
| hideBorders : Boolean True to hide the borders of each contained component, false to defer to the component's existing border settings (def... True to hide the borders of each contained component, false to defer to the component's existing border settings (defaults to false). | Container
| hideCollapseTool : Boolean True to hide the expand/collapse toggle button when collapsible = true, false to display it (defaults to false). | Panel
| hideMode : String How this component should hidden. Supported values are "visibility" (css visibility), "offsets" (negative offset posi... How this component should hidden. Supported values are "visibility" (css visibility), "offsets" (negative offset position) and "display" (css display) - defaults to "display". | Component

hideParent : Boolean
True to hide and show the component's container when hide/show is called on the component, false to hide and show the...
True to hide and show the component's container when hide/show is called on the component, false to hide and show the component itself (defaults to false). For example, this can be used as a shortcut for a hide button on a window by setting hide:true on the button when adding it to its parent container.

Component

| html : String/Object An HTML fragment, or a DomHelper specification to use as the panel's body content (defaults to ''). | Panel
| iconCls : String A CSS class that will provide a background image to be used as the panel header icon (defaults to ''). | Panel
| id : String The unique id of this component (defaults to an auto-assigned id). | Component

items : Mixed
A single item, or an array of child Components to be added to this container. Each item can be any type of object bas...
A single item, or an array of child Components to be added to this container. Each item can be any type of object based on Ext.Component.
Component config objects may also be specified in order to avoid the overhead of constructing a real Component object if lazy rendering might mean that the added Component will not be rendered immediately. To take advantage of this "lazy instantiation", set the Ext.Component.xtype config property to the registered type of the Component wanted.
For a list of all available xtypes, see Ext.Component. If a single item is being passed, it should be passed directly as an object reference (e.g., items: {...}). Multiple items should be passed as an array of objects (e.g., items: [{...}, {...}]).

Container

| keys : Object/Array A KeyMap config object (in the format expected by Ext.KeyMap.addBinding used to assign custom key handling to this pa... A KeyMap config object (in the format expected by Ext.KeyMap.addBinding used to assign custom key handling to this panel (defaults to null). | Panel

layout : String
The layout type to be used in this container. If not specified, a default Ext.layout.ContainerLayout will be created ...
The layout type to be used in this container. If not specified, a default Ext.layout.ContainerLayout will be created and used. Valid values are: accordion, anchor, border, card, column, fit, form and table. Specific config values for the chosen layout type can be specified using layoutConfig.

Container

layoutConfig : Object
This is a config object containing properties specific to the chosen layout (to be used in conjunction with the layou...
This is a config object containing properties specific to the chosen layout (to be used in conjunction with the layout config value). For complete details regarding the valid config options for each layout type, see the layout class corresponding to the type specified:

- Ext.layout.Accordion
- Ext.layout.AnchorLayout
- Ext.layout.BorderLayout
- Ext.layout.CardLayout
- Ext.layout.ColumnLayout
- Ext.layout.FitLayout
- Ext.layout.FormLayout
- Ext.layout.TableLayout

Container

| listeners : Object A config object containing one or more event handlers to be added to this object during initialization. This should b... A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once. | Observable
| loadMask : Object An Ext.LoadMask config or true to mask the grid while loading (defaults to false). | GridPanel

maskDisabled : Boolean
True to mask the panel when it is disabled, false to not mask it (defaults to true). Either way, the panel will alway...
True to mask the panel when it is disabled, false to not mask it (defaults to true). Either way, the panel will always tell its contained elements to disable themselves when it is disabled, but masking the panel can provide an additional visual cue that the panel is disabled.

Panel

| maxHeight : Number Sets the maximum height of the grid - ignored if autoHeight is not on. | GridPanel
| minButtonWidth : Number Minimum width in pixels of all buttons in this panel (defaults to 75) | Panel
| minColumnWidth : Number The minimum width a column can be resized to. Defaults to 25. | GridPanel
| monitorResize : Boolean True to automatically monitor window resize events to handle anything that is sensitive to the current size of the vi... True to automatically monitor window resize events to handle anything that is sensitive to the current size of the viewport. This value is typically managed by the chosen layout and should not need to be set manually. | Container
| monitorWindowResize : Boolean True to autoSize the grid when the window resizes. Defaults to true. | GridPanel

plugins : Object/Array
An object or array of objects that will provide custom functionality for this component. The only requirement for a v...
An object or array of objects that will provide custom functionality for this component. The only requirement for a valid plugin is that it contain an init method that accepts a reference of type Ext.Component. When a component is created, if any plugins are available, the component will call the init method on each plugin, passing a reference to itself. Each plugin can then call methods or respond to events on the component as needed to provide its functionality.

Component

| renderTo : Mixed The id of the node, a DOM node or an existing Element that will be the container to render this component into. Using... The id of the node, a DOM node or an existing Element that will be the container to render this component into. Using this config, a call to render() is not required. | Component
| selModel : Object Any subclass of AbstractSelectionModel that will provide the selection model for the grid (defaults to Ext.grid.RowSe... Any subclass of AbstractSelectionModel that will provide the selection model for the grid (defaults to Ext.grid.RowSelectionModel if not specified). | GridPanel
| shadow : Boolean/String True (or a valid Ext.Shadow Ext.Shadow.mode value) to display a shadow behind the panel, false to display no shadow (... True (or a valid Ext.Shadow Ext.Shadow.mode value) to display a shadow behind the panel, false to display no shadow (defaults to 'sides'). Note that this option only applies when floating = true. | Panel
| shadowOffset : Number The number of pixels to offset the shadow if displayed (defaults to 4). Note that this option only applies when float... The number of pixels to offset the shadow if displayed (defaults to 4). Note that this option only applies when floating = true. | Panel
| shim : Boolean False to disable the iframe shim in browsers which need one (defaults to true). Note that this option only applies wh... False to disable the iframe shim in browsers which need one (defaults to true). Note that this option only applies when floating = true. | Panel
| sm : Object Shorthand for selModel. | GridPanel
| stateEvents : Array An array of events that, when fired, should trigger this component to save its state (defaults to none). These can be... An array of events that, when fired, should trigger this component to save its state (defaults to none). These can be any types of events supported by this component, including browser or custom events (e.g., ['click', 'customerchange']). | Component
| stateId : String The unique id for this component to use for state management purposes (defaults to the component id). | Component
| store : Ext.data.Store The Ext.data.Store the grid should use as its data source (required). | GridPanel
| stripeRows : Boolean True to stripe the rows. Default is false. | GridPanel
| style : String A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.app... A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.applyStyles. | Component

tbar : Object/Array
The top toolbar of the panel. This can be either an Ext.Toolbar object or an array of buttons/button configs to be ad...
The top toolbar of the panel. This can be either an Ext.Toolbar object or an array of buttons/button configs to be added to the toolbar. Note that this is not available as a property after render. To access the top toolbar after render, use getTopToolbar.

Panel

title : String
The title text to display in the panel header (defaults to ''). When a title is specified the header element will aut...
The title text to display in the panel header (defaults to ''). When a title is specified the header element will automatically be created and displayed unless header is explicitly set to false. If you don't want to specify a title at config time, but you may want one later, you must either specify a non-empty title (a blank space ' ' will do) or header:true so that the container element will get created.

Panel

| titleCollapse : Boolean True to allow expanding and collapsing the panel (when collapsible = true) by clicking anywhere in the header bar, fa... True to allow expanding and collapsing the panel (when collapsible = true) by clicking anywhere in the header bar, false to allow it only by clicking to tool button (defaults to false). | Panel

tools : Array
An array of tool button configs to be added to the header tool area. Each tool config may contain the following prope...
An array of tool button configs to be added to the header tool area. Each tool config may contain the following properties:

- id : String

  Required. The type of tool to create. Values may be

  - `toggle` (Created by default when collapsible is `true`)
  - `close`
  - `minimize`
  - `maximize`
  - `restore`
  - `gear`
  - `pin`
  - `unpin`
  - `right`
  - `left`
  - `up`
  - `down`
  - `refresh`
  - `minus`
  - `plus`
  - `help`
  - `search`
  - `save`

- handler : Function

  Required. The function to call when clicked. Arguments passed are:

  - event : Ext.EventObject

    The click event.

  - toolEl : Ext.Element

    The tool Element.

  - Panel : Ext.Panel

    The host Panel

- scope : Object

  The scope in which to call the handler.

- qtip : String/Object

  A tip string, or a config argument to Ext.QuickTip.register

- hidden : Boolean

  True to initially render hidden.

- on : Object

  A listener config object specifiying event listeners in the format of an argument to addListener

Example usage:

    tools:[{
        id:'refresh',
        // hidden:true,
        handler: function(event, toolEl, panel){
            // refresh logic
        }
    }]

Note that apart from the toggle tool which is provided when a panel is collapsible, these tools only provide the visual button. Any required functionality must be provided by adding handlers that implement the necessary behavior.

Panel

| view : Object The Ext.grid.GridView used by the grid. This can be set before a call to render(). | GridPanel
| viewConfig : Object A config object that will be applied to the grid's UI view. Any of the config options available for Ext.grid.GridView... A config object that will be applied to the grid's UI view. Any of the config options available for Ext.grid.GridView can be specified here. | GridPanel
| width : Number The width of this component in pixels (defaults to auto). | BoxComponent

xtype : String
The registered xtype to create. This config option is not used when passing a config object into a constructor. This ...
The registered xtype to create. This config option is not used when passing a config object into a constructor. This config option is used only when lazy instantiation is being used, and a child item of a Container is being specified not as a fully instantiated Component, but as a Component config object. The xtype will be looked up at render time up to determine what type of child Component to create.
The predefined xtypes are listed here.
If you subclass Components to create your own Components, you may register them using Ext.ComponentMgr.registerType in order to be able to take advantage of lazy instantiation and rendering.

Component

## Public Properties

Property | Defined By
--- | ---

body : Ext.Element
The Panel's body Element which may be used to contain HTML content. The content may be specified in the html config,...
The Panel's body Element which may be used to contain HTML content. The content may be specified in the html config, or it may be loaded using the autoLoad config, or through the Panel's Updater. Read-only.

If this is used to load visible HTML elements in either way, then the Panel may not be used as a Layout for hosting nested Panels.

If this Panel is intended to be used as the host of a Layout (See layout then the body Element must not be loaded or changed - it is under the control of the Panel's Layout.

Panel

| buttons : Array This Panel's Array of buttons as created from the `buttons` config property. Read only. | Panel
| ddText : String Configures the text in the drag proxy (defaults to "{0} selected row(s)"). {0} is replaced with the number of select... Configures the text in the drag proxy (defaults to "{0} selected row(s)"). {0} is replaced with the number of selected rows. | GridPanel
| disabled : Boolean True if this component is disabled. Read-only. | Component
| footer : Ext.Element The Panel's footer Element. Read-only. This Element is used to house the Panel's buttons. | Panel
| header : Ext.Element The Panel's header Element. Read-only. This Element is used to house the title and tools | Panel
| hidden : Boolean True if this component is hidden. Read-only. | Component
| initialConfig : Object This Component's initial configuration specification. Read-only. | Component
| items : MixedCollection The collection of components in this container as a Ext.util.MixedCollection | Container
| ownerCt : Ext.Container The component's owner Ext.Container (defaults to undefined, and is set automatically when the component is added to a... The component's owner Ext.Container (defaults to undefined, and is set automatically when the component is added to a container). Read-only. | Component
| rendered : Boolean True if this component has been rendered. Read-only. | Component

## Public Methods

Method | Defined By
--- | ---

EditorGridPanel()
Parameters:

- None.

Returns:

- ``

EditorGridPanel

add( `Ext.Component/Object component` ) : Ext.Component
Adds a Component to this Container. Fires the beforeadd event before adding, then fires the add event after the compo...
Adds a Component to this Container. Fires the beforeadd event before adding, then fires the add event after the component has been added.
Parameters:

- `component` : Ext.Component/Object
  The component to add.
  Ext uses lazy rendering, and will only render the added Component should it become necessary.
  A Component config object may be passed in order to avoid the overhead of constructing a real Component object if lazy rendering might mean that the added Component will not be rendered immediately. To take advantage of this "lazy instantiation", set the Ext.Component.xtype config property to the registered type of the Component wanted.
  For a list of all available xtypes, see Ext.Component.

Returns:

- `Ext.Component`
  component The Component (or config object) that was added with the Container's default config values applied.

Container

addButton( `String/Object config`, `Function handler`, `Object scope` ) : Ext.Button
Adds a button to this panel. Note that this method must be called prior to rendering. The preferred approach is to ...
Adds a button to this panel. Note that this method must be called prior to rendering. The preferred approach is to add buttons via the buttons config.
Parameters:

- `config` : String/Object
  A valid Ext.Button config. A string will become the text for a default button config, an object will be treated as a button config object.
- `handler` : Function
  The function to be called on button Ext.Button.click
- `scope` : Object
  The scope to use for the button handler function

Returns:

- `Ext.Button`
  The button that was added

Panel

addClass( `string cls` ) : void
Adds a CSS class to the component's underlying element.
Adds a CSS class to the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to add

Returns:

- `void`

Component

addEvents( `Object object` ) : void
Used to define events on this Observable
Used to define events on this Observable
Parameters:

- `object` : Object
  The object with the events defined

Returns:

- `void`

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this component
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope : Object

    The scope in which to execute the handler function. The handler function's "this" context.

  - delay : Number

    The number of milliseconds to delay the invocation of the handler after the event fires.

  - single : Boolean

    True to add a handler to handle just the next firing of the event, and then remove itself.

  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

      el.on('click', this.onClick, this, {
          single: true,
          delay: 100,
          forumId: 4
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      foo.on({
          'click' : {
              fn: this.onClick,
              scope: this,
              delay: 100
          },
          'mouseover' : {
              fn: this.onMouseOver,
              scope: this
          },
          'mouseout' : {
              fn: this.onMouseOut,
              scope: this
          }
      });

  Or a shorthand syntax:

      foo.on({
          'click' : this.onClick,
          'mouseover' : this.onMouseOver,
          'mouseout' : this.onMouseOut,
           scope: this
      });

Returns:

- `void`

Observable

applyToMarkup( `String/HTMLElement el` ) : void
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Parameters:

- `el` : String/HTMLElement

Returns:

- `void`

Component

bubble( `Function fn`, [`Object scope`], [`Array args`] ) : void
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of...
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of function call will be the scope provided or the current component. The arguments to the function will be the args provided or the current component. If the function returns false at any point, the bubble is stopped.
Parameters:

- `fn` : Function
  The function to call
- `scope` : Object
  (optional) The scope of the function (defaults to current node)
- `args` : Array
  (optional) The args to call the function with (default to passing the current component)

Returns:

- `void`

Container

cascade( `Function fn`, [`Object scope`], [`Array args`] ) : void
Cascades down the component/container heirarchy from this component (called first), calling the specified function wi...
Cascades down the component/container heirarchy from this component (called first), calling the specified function with each component. The scope (this) of function call will be the scope provided or the current component. The arguments to the function will be the args provided or the current component. If the function returns false at any point, the cascade is stopped on that branch.
Parameters:

- `fn` : Function
  The function to call
- `scope` : Object
  (optional) The scope of the function (defaults to current component)
- `args` : Array
  (optional) The args to call the function with (defaults to passing the current component)

Returns:

- `void`

Container

cloneConfig( `Object overrides` ) : Ext.Component
Clone the current component using the original config values passed into this instance by default.
Clone the current component using the original config values passed into this instance by default.
Parameters:

- `overrides` : Object
  A new config containing any properties to override in the cloned version. An id property can be passed on this object, otherwise one will be generated to avoid duplicates.

Returns:

- `Ext.Component`
  clone The cloned copy of this component

Component

collapse( `Boolean animate` ) : Ext.Panel
Collapses the panel body so that it becomes hidden. Fires the beforecollapse event which will cancel the collapse ac...
Collapses the panel body so that it becomes hidden. Fires the beforecollapse event which will cancel the collapse action if it returns false.
Parameters:

- `animate` : Boolean
  True to animate the transition, else false (defaults to the value of the animCollapse panel config)

Returns:

- `Ext.Panel`
  this

Panel

destroy() : void
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the c...
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the component from its Ext.Container (if applicable) and unregistering it from Ext.ComponentMgr. Destruction is generally handled automatically by the framework and this method should usually not need to be called directly.
Parameters:

- None.

Returns:

- `void`

Component

disable() : Ext.Component
Disable this component.
Disable this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

doLayout() : void
Force this container's layout to be recalculated. A call to this function is required after adding a new component to...
Force this container's layout to be recalculated. A call to this function is required after adding a new component to an already rendered container. If you are not dynamically adding and removing components after render, this function will generally not need to be called.
Parameters:

- None.

Returns:

- `void`

Container

enable() : Ext.Component
Enable this component.
Enable this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

expand( `Boolean animate` ) : Ext.Panel
Expands the panel body so that it becomes visible. Fires the beforeexpand event which will cancel the expand action ...
Expands the panel body so that it becomes visible. Fires the beforeexpand event which will cancel the expand action if it returns false.
Parameters:

- `animate` : Boolean
  True to animate the transition, else false (defaults to the value of the animCollapse panel config)

Returns:

- `Ext.Panel`
  this

Panel

find( `String prop`, `String value` ) : Array
Find a component under this container at any level by property
Find a component under this container at any level by property
Parameters:

- `prop` : String
- `value` : String

Returns:

- `Array`
  Array of Ext.Components

Container

findBy( `Function fcn`, [`Object scope`] ) : Array
Find a component under this container at any level by a custom function. If the passed function returns true, the com...
Find a component under this container at any level by a custom function. If the passed function returns true, the component will be included in the results. The passed function is called with the arguments (component, this container).
Parameters:

- `fcn` : Function
- `scope` : Object
  (optional)

Returns:

- `Array`
  Array of Ext.Components

Container

findById( `String id` ) : Ext.Component
Find a component under this container at any level by id
Find a component under this container at any level by id
Parameters:

- `id` : String

Returns:

- `Ext.Component`

Container

findByType( `String/Class xtype` ) : Array
Find a component under this container at any level by xtype or class
Find a component under this container at any level by xtype or class
Parameters:

- `xtype` : String/Class
  The xtype string for a component, or the class of the component directly

Returns:

- `Array`
  Array of Ext.Components

Container

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name).
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

Observable

focus( [`Boolean selectText`], [`Boolean/Number delay`] ) : Ext.Component
Try to focus this component.
Try to focus this component.
Parameters:

- `selectText` : Boolean
  (optional) If applicable, true to also select the text in this component
- `delay` : Boolean/Number
  (optional) Delay the focus this number of milliseconds (true for 10 milliseconds)

Returns:

- `Ext.Component`
  this

Component

getBottomToolbar() : Ext.Toolbar
Returns the toolbar from the bottom (bbar) section of the panel.
Returns the toolbar from the bottom (bbar) section of the panel.
Parameters:

- None.

Returns:

- `Ext.Toolbar`
  The toolbar

Panel

getBox( [`Boolean local`] ) : Object
Gets the current box measurements of the component's underlying element.
Gets the current box measurements of the component's underlying element.
Parameters:

- `local` : Boolean
  (optional) If true the element's left and top are returned instead of page XY (defaults to false)

Returns:

- `Object`
  box An object in the format {x, y, width, height}

BoxComponent

getColumnModel() : ColumnModel
Returns the grid's ColumnModel.
Returns the grid's ColumnModel.
Parameters:

- None.

Returns:

- `ColumnModel`
  The column model

GridPanel

getComponent( `String/Number id` ) : Ext.Component
Gets a direct child Component by id, or by index.
Gets a direct child Component by id, or by index.
Parameters:

- `id` : String/Number
  or index of child Component to return.

Returns:

- `Ext.Component`

Container

getDragDropText() : String
Called to get grid's drag proxy text, by default returns this.ddText.
Called to get grid's drag proxy text, by default returns this.ddText.
Parameters:

- None.

Returns:

- `String`
  The text

GridPanel

getEl() : Ext.Element
Returns the underlying Ext.Element.
Returns the underlying Ext.Element.
Parameters:

- None.

Returns:

- `Ext.Element`
  The element

Component

getFrameHeight() : Number
Returns the height in pixels of the framing elements of this panel (including any top and bottom bars and header and ...
Returns the height in pixels of the framing elements of this panel (including any top and bottom bars and header and footer elements, but not including the body height). To retrieve the body height see getInnerHeight.
Parameters:

- None.

Returns:

- `Number`
  The frame height

Panel

getFrameWidth() : Number
Returns the width in pixels of the framing elements of this panel (not including the body width). To retrieve the bo...
Returns the width in pixels of the framing elements of this panel (not including the body width). To retrieve the body width see getInnerWidth.
Parameters:

- None.

Returns:

- `Number`
  The frame width

Panel

getGridEl() : Element
Returns the grid's underlying element.
Returns the grid's underlying element.
Parameters:

- None.

Returns:

- `Element`
  The element

GridPanel

getId() : String
Returns the id of this component.
Returns the id of this component.
Parameters:

- None.

Returns:

- `String`

Component

getInnerHeight() : Number
Returns the height in pixels of the body element (not including the height of any framing elements). For the frame he...
Returns the height in pixels of the body element (not including the height of any framing elements). For the frame height see getFrameHeight.
Parameters:

- None.

Returns:

- `Number`
  The body height

Panel

getInnerWidth() : Number
Returns the width in pixels of the body element (not including the width of any framing elements). For the frame widt...
Returns the width in pixels of the body element (not including the width of any framing elements). For the frame width see getFrameWidth.
Parameters:

- None.

Returns:

- `Number`
  The body width

Panel

getItemId() : String
Returns the item id of this component.
Returns the item id of this component.
Parameters:

- None.

Returns:

- `String`

Component

getLayout() : ContainerLayout
Returns the layout currently in use by the container. If the container does not currently have a layout set, a defau...
Returns the layout currently in use by the container. If the container does not currently have a layout set, a default Ext.layout.ContainerLayout will be created and set as the container's layout.
Parameters:

- None.

Returns:

- `ContainerLayout`
  layout The container's layout

Container

getPosition( [`Boolean local`] ) : Array
Gets the current XY position of the component's underlying element.
Gets the current XY position of the component's underlying element.
Parameters:

- `local` : Boolean
  (optional) If true the element's left and top are returned instead of page XY (defaults to false)

Returns:

- `Array`
  The XY position of the element (e.g., [100, 200])

BoxComponent

getSelectionModel() : SelectionModel
Returns the grid's SelectionModel.
Returns the grid's SelectionModel.
Parameters:

- None.

Returns:

- `SelectionModel`
  The selection model

GridPanel

getSize() : Object
Gets the current size of the component's underlying element.
Gets the current size of the component's underlying element.
Parameters:

- None.

Returns:

- `Object`
  An object containing the element's size {width: (element width), height: (element height)}

BoxComponent

getStore() : DataSource
Returns the grid's data store.
Returns the grid's data store.
Parameters:

- None.

Returns:

- `DataSource`
  The store

GridPanel

getTopToolbar() : Ext.Toolbar
Returns the toolbar from the top (tbar) section of the panel.
Returns the toolbar from the top (tbar) section of the panel.
Parameters:

- None.

Returns:

- `Ext.Toolbar`
  The toolbar

Panel

getUpdater() : Ext.Updater
Get the Ext.Updater for this panel. Enables you to perform Ajax updates of this panel's body.
Get the Ext.Updater for this panel. Enables you to perform Ajax updates of this panel's body.
Parameters:

- None.

Returns:

- `Ext.Updater`
  The Updater

Panel

getView() : GridView
Returns the grid's GridView object.
Returns the grid's GridView object.
Parameters:

- None.

Returns:

- `GridView`
  The grid view

GridPanel

getXType() : String
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ex...
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXType());  // alerts 'textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype

Component

getXTypes() : String
Returns this component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext...
Returns this component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXTypes());  // alerts 'component/box/field/textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype hierarchy string

Component

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

hide() : Ext.Component
Hide this component.
Hide this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

initComponent() : void
Parameters:

- None.

Returns:

- `void`

BoxComponent

insert( `Number index`, `Ext.Component component` ) : Ext.Component
Inserts a Component into this Container at a specified index. Fires the beforeadd event before inserting, then fires ...
Inserts a Component into this Container at a specified index. Fires the beforeadd event before inserting, then fires the add event after the Component has been inserted.
Parameters:

- `index` : Number
  The index at which the Component will be inserted into the Container's items collection
- `component` : Ext.Component
  The child Component to insert.
  Ext uses lazy rendering, and will only render the inserted Component should it become necessary.
  A Component config object may be passed in order to avoid the overhead of constructing a real Component object if lazy rendering might mean that the inserted Component will not be rendered immediately. To take advantage of this "lazy instantiation", set the Ext.Component.xtype config property to the registered type of the Component wanted.
  For a list of all available xtypes, see Ext.Component.

Returns:

- `Ext.Component`
  component The Component (or config object) that was inserted with the Container's default config values applied.

Container

isVisible() : void
Returns true if this component is visible.
Returns true if this component is visible.
Parameters:

- None.

Returns:

- `void`

Component

isXType( `String xtype`, [`Boolean shallow`] ) : void
Tests whether or not this component is of a specific xtype. This can test whether this component is descended from th...
Tests whether or not this component is of a specific xtype. This can test whether this component is descended from the xtype (default) or whether it is directly of the xtype specified (shallow = true). For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    var isText = t.isXType('textfield');        // true
    var isBoxSubclass = t.isXType('box');       // true, descended from BoxComponent
    var isBoxInstance = t.isXType('box', true); // false, not a direct BoxComponent instance

Parameters:

- `xtype` : String
  The xtype to check for this component
- `shallow` : Boolean
  (optional) False to check whether this component is descended from the xtype (this is the default), or true to check whether this component is directly of the specified xtype.

Returns:

- `void`

Component

load( `Object/String/Function config` ) : Ext.Panel
Loads this content panel immediately with content returned from an XHR call.
Loads this content panel immediately with content returned from an XHR call.
Parameters:

- `config` : Object/String/Function
  A config object containing any of the following options:

      panel.load({
          url: "your-url.php",
          params: {param1: "foo", param2: "bar"}, // or a URL encoded string
          callback: yourFunction,
          scope: yourObject, // optional scope for the callback
          discardUrl: false,
          nocache: false,
          text: "Loading...",
          timeout: 30,
          scripts: false
      });

  The only required property is url. The optional properties nocache, text and scripts are shorthand for disableCaching, indicatorText and loadScripts and are used to set their associated property on this panel Updater instance.

Returns:

- `Ext.Panel`
  this

Panel

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this element (shorthand for addListener)
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional)

Returns:

- `void`

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

Observable

reconfigure( `Ext.data.Store store`, `Ext.grid.ColumnModel colModel` ) : void
Reconfigures the grid to use a different Store and Column Model. The View will be bound to the new objects and refres...
Reconfigures the grid to use a different Store and Column Model. The View will be bound to the new objects and refreshed.
Parameters:

- `store` : Ext.data.Store
  The new Ext.data.Store object
- `colModel` : Ext.grid.ColumnModel
  The new Ext.grid.ColumnModel object

Returns:

- `void`

GridPanel

remove( `Component/String component`, [`Boolean autoDestroy`] ) : void
Removes a component from this container. Fires the beforeremove event before removing, then fires the remove event a...
Removes a component from this container. Fires the beforeremove event before removing, then fires the remove event after the component has been removed.
Parameters:

- `component` : Component/String
  The component reference or id to remove
- `autoDestroy` : Boolean
  (optional) True to automatically invoke the component's Ext.Component.destroy function

Returns:

- `void`

Container

removeClass( `string cls` ) : void
Removes a CSS class from the component's underlying element.
Removes a CSS class from the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to remove

Returns:

- `void`

Component

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

render( [`Mixed container`], [`String/Number position`] ) : void
If this is a lazy rendering component, render it to its container element.
If this is a lazy rendering component, render it to its container element.
Parameters:

- `container` : Mixed
  (optional) The element this component should be rendered into. If it is being applied to existing markup, this should be left off.
- `position` : String/Number
  (optional) The element ID or DOM node index within the container before which this component will be inserted (defaults to appending to the end of the container)

Returns:

- `void`

Component

resumeEvents() : void
Resume firing events. (see suspendEvents)
Resume firing events. (see suspendEvents)
Parameters:

- None.

Returns:

- `void`

Observable

setDisabled( `Boolean disabled` ) : void
Convenience function for setting disabled/enabled by boolean.
Convenience function for setting disabled/enabled by boolean.
Parameters:

- `disabled` : Boolean

Returns:

- `void`

Component

setHeight( `Number height` ) : Ext.BoxComponent
Sets the height of the component. This method fires the resize event.
Sets the height of the component. This method fires the resize event.
Parameters:

- `height` : Number
  The new height to set

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setIconClass( `String cls` ) : void
Sets the CSS class that provides the icon image for this panel. This method will replace any existing icon class if ...
Sets the CSS class that provides the icon image for this panel. This method will replace any existing icon class if one has already been set.
Parameters:

- `cls` : String
  The new CSS class name

Returns:

- `void`

Panel

setPagePosition( `Number x`, `Number y` ) : Ext.BoxComponent
Sets the page XY position of the component. To set the left and top instead, use setPosition. This method fires the ...
Sets the page XY position of the component. To set the left and top instead, use setPosition. This method fires the move event.
Parameters:

- `x` : Number
  The new x position
- `y` : Number
  The new y position

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setPosition( `Number left`, `Number top` ) : Ext.BoxComponent
Sets the left and top of the component. To set the page XY position instead, use setPagePosition. This method fires ...
Sets the left and top of the component. To set the page XY position instead, use setPagePosition. This method fires the move event.
Parameters:

- `left` : Number
  The new left
- `top` : Number
  The new top

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setSize( `Number/Object width`, `Number height` ) : Ext.BoxComponent
Sets the width and height of the component. This method fires the resize event. This method can accept either width...
Sets the width and height of the component. This method fires the resize event. This method can accept either width and height as separate numeric arguments, or you can pass a size object like {width:10, height:20}.
Parameters:

- `width` : Number/Object
  The new width to set, or a size object in the format {width, height}
- `height` : Number
  The new height to set (not required if a size object is passed as the first arg)

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setTitle( `String title`, `String (optional)` ) : void
Sets the title text for the panel and optionally the icon class.
Sets the title text for the panel and optionally the icon class.
Parameters:

- `title` : String
  The title text to set
- `(optional)` : String
  iconCls A custon, user-defined CSS class that provides the icon image for this panel

Returns:

- `void`

Panel

setVisible( `Boolean visible` ) : Ext.Component
Convenience function to hide or show this component by boolean.
Convenience function to hide or show this component by boolean.
Parameters:

- `visible` : Boolean
  True to show, false to hide

Returns:

- `Ext.Component`
  this

Component

setWidth( `Number width` ) : Ext.BoxComponent
Sets the width of the component. This method fires the resize event.
Sets the width of the component. This method fires the resize event.
Parameters:

- `width` : Number
  The new width to set

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

show() : Ext.Component
Show this component.
Show this component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

startEditing( `Number rowIndex`, `Number colIndex` ) : void
Starts editing the specified for the specified row/column
Starts editing the specified for the specified row/column
Parameters:

- `rowIndex` : Number
- `colIndex` : Number

Returns:

- `void`

EditorGridPanel

stopEditing() : void
Stops any active editing
Stops any active editing
Parameters:

- None.

Returns:

- `void`

EditorGridPanel

suspendEvents() : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- None.

Returns:

- `void`

Observable

syncSize() : Ext.BoxComponent
Force the component's size to recalculate based on the underlying element's current height and width.
Force the component's size to recalculate based on the underlying element's current height and width.
Parameters:

- None.

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

toggleCollapse( `Boolean animate` ) : Ext.Panel
Shortcut for performing an expand or collapse based on the current state of the panel.
Shortcut for performing an expand or collapse based on the current state of the panel.
Parameters:

- `animate` : Boolean
  True to animate the transition, else false (defaults to the value of the animCollapse panel config)

Returns:

- `Ext.Panel`
  this

Panel

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener (shorthand for removeListener)
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

updateBox( `Object box` ) : Ext.BoxComponent
Sets the current box measurements of the component's underlying element.
Sets the current box measurements of the component's underlying element.
Parameters:

- `box` : Object
  An object in the format {x, y, width, height}

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

## Public Events

Event | Defined By
--- | ---

activate : ( `Ext.Panel p` )
Fires after the Panel has been visually activated. Note that Panels do not directly support being activated, but some...
Fires after the Panel has been visually activated. Note that Panels do not directly support being activated, but some Panel subclasses do (like Ext.Window). Panels which are child Components of a TabPanel fire the activate and deactivate events under the control of the TabPanel.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  The Panel that has been activated.

Panel

add : ( `Ext.Container this`, `Ext.Component component`, `Number index` )
Fires after any Ext.Component is added or inserted into the container.
Fires after any Ext.Component is added or inserted into the container.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component that was added
- `index` : Number
  The index at which the component was added to the container's items collection

Container

afteredit : ( `Object e` )
Fires after a cell is edited. grid - This grid record - The record being edited field - The field name being edited...
Fires after a cell is edited.

- grid - This grid
- record - The record being edited
- field - The field name being edited
- value - The value being set
- originalValue - The original value for the field, before the edit.
- row - The grid row index
- column - The grid column index

Listeners will be called with the following arguments:

- `e` : Object
  An edit event (see above for description)

EditorGridPanel

afterlayout : ( `Ext.Container this`, `ContainerLayout layout` )
Fires when the components in this container are arranged by the associated layout manager.
Fires when the components in this container are arranged by the associated layout manager.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `layout` : ContainerLayout
  The ContainerLayout implementation for this container

Container

beforeadd : ( `Ext.Container this`, `Ext.Component component`, `Number index` )
Fires before any Ext.Component is added or inserted into the container. A handler can return false to cancel the add.
Fires before any Ext.Component is added or inserted into the container. A handler can return false to cancel the add.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component being added
- `index` : Number
  The index at which the component will be added to the container's items collection

Container

beforeclose : ( `Ext.Panel p` )
Fires before the Panel is closed. Note that Panels do not directly support being closed, but some Panel subclasses d...
Fires before the Panel is closed. Note that Panels do not directly support being closed, but some Panel subclasses do (like Ext.Window). This event only applies to such subclasses. A handler can return false to cancel the close.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  The Panel being closed.

Panel

beforecollapse : ( `Ext.Panel p`, `Boolean animate` )
Fires before the Panel is collapsed. A handler can return false to cancel the collapse.
Fires before the Panel is collapsed. A handler can return false to cancel the collapse.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  the Panel being collapsed.
- `animate` : Boolean
  True if the collapse is animated, else false.

Panel

beforedestroy : ( `Ext.Component this` )
Fires before the component is destroyed. Return false to stop the destroy.
Fires before the component is destroyed. Return false to stop the destroy.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforeedit : ( `Object e` )
Fires before cell editing is triggered. The edit event object has the following properties grid - This grid record ...
Fires before cell editing is triggered. The edit event object has the following properties

- grid - This grid
- record - The record being edited
- field - The field name being edited
- value - The value for the field being edited.
- row - The grid row index
- column - The grid column index
- cancel - Set this to true to cancel the edit or return false from your handler.

Listeners will be called with the following arguments:

- `e` : Object
  An edit event (see above for description)

EditorGridPanel

beforeexpand : ( `Ext.Panel p`, `Boolean animate` )
Fires before the Panel is expanded. A handler can return false to cancel the expand.
Fires before the Panel is expanded. A handler can return false to cancel the expand.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  The Panel being expanded.
- `animate` : Boolean
  True if the expand is animated, else false.

Panel

beforehide : ( `Ext.Component this` )
Fires before the component is hidden. Return false to stop the hide.
Fires before the component is hidden. Return false to stop the hide.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforeremove : ( `Ext.Container this`, `Ext.Component component` )
Fires before any Ext.Component is removed from the container. A handler can return false to cancel the remove.
Fires before any Ext.Component is removed from the container. A handler can return false to cancel the remove.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component being removed

Container

beforerender : ( `Ext.Component this` )
Fires before the component is rendered. Return false to stop the render.
Fires before the component is rendered. Return false to stop the render.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforeshow : ( `Ext.Component this` )
Fires before the component is shown. Return false to stop the show.
Fires before the component is shown. Return false to stop the show.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforestaterestore : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is restored. Return false to stop the restore.
Fires before the state of the component is restored. Return false to stop the restore.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component

beforestatesave : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component

bodyresize : ( `Ext.Panel p`, `Number width`, `Number height` )
Fires after the Panel has been resized.
Fires after the Panel has been resized.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  the Panel which has been resized.
- `width` : Number
  The Panel's new width.
- `height` : Number
  The Panel's new height.

Panel

bodyscroll : ( `Number scrollLeft`, `Number scrollTop` )
Fires when the body element is scrolled
Fires when the body element is scrolled
Listeners will be called with the following arguments:

- `scrollLeft` : Number
- `scrollTop` : Number

GridPanel

cellclick : ( `Grid this`, `Number rowIndex`, `Number columnIndex`, `Ext.EventObject e` )
Fires when a cell is clicked. The data for the cell is drawn from the Record for this row. To access the data in the ...
Fires when a cell is clicked. The data for the cell is drawn from the Record for this row. To access the data in the listener function use the following technique:

    function(grid, rowIndex, columnIndex, e) {
            var record = grid.getStore().getAt(rowIndex);  // Get the Record
            var fieldName = grid.getColumnModel().getDataIndex(columnIndex); // Get field name
            var data = record.get(fieldName);
        }

Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `columnIndex` : Number
- `e` : Ext.EventObject

GridPanel

cellcontextmenu : ( `Grid this`, `Number rowIndex`, `Number cellIndex`, `Ext.EventObject e` )
Fires when a cell is right clicked
Fires when a cell is right clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `cellIndex` : Number
- `e` : Ext.EventObject

GridPanel

celldblclick : ( `Grid this`, `Number rowIndex`, `Number columnIndex`, `Ext.EventObject e` )
Fires when a cell is double clicked
Fires when a cell is double clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `columnIndex` : Number
- `e` : Ext.EventObject

GridPanel

cellmousedown : ( `Grid this`, `Number rowIndex`, `Number columnIndex`, `Ext.EventObject e` )
Fires before a cell is clicked
Fires before a cell is clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `columnIndex` : Number
- `e` : Ext.EventObject

GridPanel

click : ( `Ext.EventObject e` )
The raw click event for the entire grid.
The raw click event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

close : ( `Ext.Panel p` )
Fires after the Panel is closed. Note that Panels do not directly support being closed, but some Panel subclasses do...
Fires after the Panel is closed. Note that Panels do not directly support being closed, but some Panel subclasses do (like Ext.Window).
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  The Panel that has been closed.

Panel

collapse : ( `Ext.Panel p` )
Fires after the Panel has been collapsed.
Fires after the Panel has been collapsed.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  the Panel that has been collapsed.

Panel

columnmove : ( `Number oldIndex`, `Number newIndex` )
Fires when the user moves a column
Fires when the user moves a column
Listeners will be called with the following arguments:

- `oldIndex` : Number
- `newIndex` : Number

GridPanel

columnresize : ( `Number columnIndex`, `Number newSize` )
Fires when the user resizes a column
Fires when the user resizes a column
Listeners will be called with the following arguments:

- `columnIndex` : Number
- `newSize` : Number

GridPanel

contextmenu : ( `Ext.EventObject e` )
The raw contextmenu event for the entire grid.
The raw contextmenu event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

dblclick : ( `Ext.EventObject e` )
The raw dblclick event for the entire grid.
The raw dblclick event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

deactivate : ( `Ext.Panel p` )
Fires after the Panel has been visually deactivated. Note that Panels do not directly support being deactivated, but ...
Fires after the Panel has been visually deactivated. Note that Panels do not directly support being deactivated, but some Panel subclasses do (like Ext.Window). Panels which are child Components of a TabPanel fire the activate and deactivate events under the control of the TabPanel.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  The Panel that has been deactivated.

Panel

destroy : ( `Ext.Component this` )
Fires after the component is destroyed.
Fires after the component is destroyed.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

disable : ( `Ext.Component this` )
Fires after the component is disabled.
Fires after the component is disabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

enable : ( `Ext.Component this` )
Fires after the component is enabled.
Fires after the component is enabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

expand : ( `Ext.Panel p` )
Fires after the Panel has been expanded.
Fires after the Panel has been expanded.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  The Panel that has been expanded.

Panel

headerclick : ( `Grid this`, `Number columnIndex`, `Ext.EventObject e` )
Fires when a header is clicked
Fires when a header is clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `columnIndex` : Number
- `e` : Ext.EventObject

GridPanel

headercontextmenu : ( `Grid this`, `Number columnIndex`, `Ext.EventObject e` )
Fires when a header is right clicked
Fires when a header is right clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `columnIndex` : Number
- `e` : Ext.EventObject

GridPanel

headerdblclick : ( `Grid this`, `Number columnIndex`, `Ext.EventObject e` )
Fires when a header cell is double clicked
Fires when a header cell is double clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `columnIndex` : Number
- `e` : Ext.EventObject

GridPanel

headermousedown : ( `Grid this`, `Number columnIndex`, `Ext.EventObject e` )
Fires before a header is clicked
Fires before a header is clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `columnIndex` : Number
- `e` : Ext.EventObject

GridPanel

hide : ( `Ext.Component this` )
Fires after the component is hidden.
Fires after the component is hidden.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

keydown : ( `Ext.EventObject e` )
The raw keydown event for the entire grid.
The raw keydown event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

keypress : ( `Ext.EventObject e` )
The raw keypress event for the entire grid.
The raw keypress event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

mousedown : ( `Ext.EventObject e` )
The raw mousedown event for the entire grid.
The raw mousedown event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

mouseout : ( `Ext.EventObject e` )
The raw mouseout event for the entire grid.
The raw mouseout event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

mouseover : ( `Ext.EventObject e` )
The raw mouseover event for the entire grid.
The raw mouseover event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

mouseup : ( `Ext.EventObject e` )
The raw mouseup event for the entire grid.
The raw mouseup event for the entire grid.
Listeners will be called with the following arguments:

- `e` : Ext.EventObject

GridPanel

move : ( `Ext.Component this`, `Number x`, `Number y` )
Fires after the component is moved.
Fires after the component is moved.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `x` : Number
  The new x position
- `y` : Number
  The new y position

BoxComponent

remove : ( `Ext.Container this`, `Ext.Component component` )
Fires after any Ext.Component is removed from the container.
Fires after any Ext.Component is removed from the container.
Listeners will be called with the following arguments:

- `this` : Ext.Container
- `component` : Ext.Component
  The component that was removed

Container

render : ( `Ext.Component this` )
Fires after the component is rendered.
Fires after the component is rendered.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

resize : ( `Ext.Component this`, `Number adjWidth`, `Number adjHeight`, `Number rawWidth`, `Number rawHeight` )
Fires after the component is resized.
Fires after the component is resized.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `adjWidth` : Number
  The box-adjusted width that was set
- `adjHeight` : Number
  The box-adjusted height that was set
- `rawWidth` : Number
  The width that was originally specified
- `rawHeight` : Number
  The height that was originally specified

BoxComponent

rowclick : ( `Grid this`, `Number rowIndex`, `Ext.EventObject e` )
Fires when a row is clicked
Fires when a row is clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `e` : Ext.EventObject

GridPanel

rowcontextmenu : ( `Grid this`, `Number rowIndex`, `Ext.EventObject e` )
Fires when a row is right clicked
Fires when a row is right clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `e` : Ext.EventObject

GridPanel

rowdblclick : ( `Grid this`, `Number rowIndex`, `Ext.EventObject e` )
Fires when a row is double clicked
Fires when a row is double clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `e` : Ext.EventObject

GridPanel

rowmousedown : ( `Grid this`, `Number rowIndex`, `Ext.EventObject e` )
Fires before a row is clicked
Fires before a row is clicked
Listeners will be called with the following arguments:

- `this` : Grid
- `rowIndex` : Number
- `e` : Ext.EventObject

GridPanel

show : ( `Ext.Component this` )
Fires after the component is shown.
Fires after the component is shown.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

sortchange : ( `Grid this`, `Object sortInfo` )
Fires when the grid's store sort changes
Fires when the grid's store sort changes
Listeners will be called with the following arguments:

- `this` : Grid
- `sortInfo` : Object
  An object with the keys field and direction

GridPanel

staterestore : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is restored.
Fires after the state of the component is restored.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component

statesave : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is saved to the configured state provider.
Fires after the state of the component is saved to the configured state provider.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values

Component

titlechange : ( `Ext.Panel p`, `String The` )
Fires after the Panel title has been set or changed.
Fires after the Panel title has been set or changed.
Listeners will be called with the following arguments:

- `p` : Ext.Panel
  the Panel which has had its title changed.
- `The` : String
  new title.

Panel

validateedit : ( `Object e` )
Fires after a cell is edited, but before the value is set in the record. Return false to cancel the change. The edit ...
Fires after a cell is edited, but before the value is set in the record. Return false to cancel the change. The edit event object has the following properties

- grid - This grid
- record - The record being edited
- field - The field name being edited
- value - The value being set
- originalValue - The original value for the field, before the edit.
- row - The grid row index
- column - The grid column index
- cancel - Set this to true to cancel the edit or return false from your handler.

Listeners will be called with the following arguments:

- `e` : Object
  An edit event (see above for description)

EditorGridPanel